diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlPluralRules.cpp webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlPluralRules.cpp
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlPluralRules.cpp	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlPluralRules.cpp	2021-05-22 16:01:09.158682536 -0500
@@ -36,7 +36,25 @@ namespace JSC {
 
 const ClassInfo IntlPluralRules::s_info = { "Object", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(IntlPluralRules) };
 
-using UEnumerationDeleter = ICUDeleter<uenum_close>;
+void IntlPluralRules::UPluralRulesDeleter::operator()(UPluralRules* pluralRules) const
+{
+    if (pluralRules)
+        uplrules_close(pluralRules);
+}
+
+void IntlPluralRules::UNumberFormatDeleter::operator()(UNumberFormat* numberFormat) const
+{
+    if (numberFormat)
+        unum_close(numberFormat);
+}
+
+struct UEnumerationDeleter {
+    void operator()(UEnumeration* enumeration) const
+    {
+        if (enumeration)
+            uenum_close(enumeration);
+    }
+};
 
 IntlPluralRules* IntlPluralRules::create(VM& vm, Structure* structure)
 {
@@ -104,9 +122,35 @@ void IntlPluralRules::initializePluralRu
     m_type = intlOption<Type>(globalObject, options, vm.propertyNames->type, { { "cardinal"_s, Type::Cardinal }, { "ordinal"_s, Type::Ordinal } }, "type must be \"cardinal\" or \"ordinal\""_s, Type::Cardinal);
     RETURN_IF_EXCEPTION(scope, void());
 
-    setNumberFormatDigitOptions(globalObject, this, options, 0, 3, IntlNotation::Standard);
+    unsigned minimumIntegerDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumIntegerDigits"), 1, 21, 1);
+    RETURN_IF_EXCEPTION(scope, void());
+    m_minimumIntegerDigits = minimumIntegerDigits;
+
+    unsigned minimumFractionDigitsDefault = 0;
+    unsigned minimumFractionDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumFractionDigits"), 0, 20, minimumFractionDigitsDefault);
+    RETURN_IF_EXCEPTION(scope, void());
+    m_minimumFractionDigits = minimumFractionDigits;
+
+    unsigned maximumFractionDigitsDefault = std::max(minimumFractionDigits, 3u);
+    unsigned maximumFractionDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "maximumFractionDigits"), minimumFractionDigits, 20, maximumFractionDigitsDefault);
+    RETURN_IF_EXCEPTION(scope, void());
+    m_maximumFractionDigits = maximumFractionDigits;
+
+    JSValue minimumSignificantDigitsValue = options->get(globalObject, Identifier::fromString(vm, "minimumSignificantDigits"));
+    RETURN_IF_EXCEPTION(scope, void());
+
+    JSValue maximumSignificantDigitsValue = options->get(globalObject, Identifier::fromString(vm, "maximumSignificantDigits"));
     RETURN_IF_EXCEPTION(scope, void());
 
+    if (!minimumSignificantDigitsValue.isUndefined() || !maximumSignificantDigitsValue.isUndefined()) {
+        unsigned minimumSignificantDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumSignificantDigits"), 1, 21, 1);
+        RETURN_IF_EXCEPTION(scope, void());
+        unsigned maximumSignificantDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "maximumSignificantDigits"), minimumSignificantDigits, 21, 21);
+        RETURN_IF_EXCEPTION(scope, void());
+        m_minimumSignificantDigits = minimumSignificantDigits;
+        m_maximumSignificantDigits = maximumSignificantDigits;
+    }
+
     UErrorCode status = U_ZERO_ERROR;
     m_numberFormat = std::unique_ptr<UNumberFormat, UNumberFormatDeleter>(unum_open(UNUM_DECIMAL, nullptr, 0, m_locale.utf8().data(), nullptr, &status));
     if (U_FAILURE(status)) {
@@ -114,20 +158,14 @@ void IntlPluralRules::initializePluralRu
         return;
     }
 
-    switch (m_roundingType) {
-    case IntlRoundingType::FractionDigits:
+    if (m_minimumSignificantDigits) {
+        unum_setAttribute(m_numberFormat.get(), UNUM_SIGNIFICANT_DIGITS_USED, true);
+        unum_setAttribute(m_numberFormat.get(), UNUM_MIN_SIGNIFICANT_DIGITS, m_minimumSignificantDigits.value());
+        unum_setAttribute(m_numberFormat.get(), UNUM_MAX_SIGNIFICANT_DIGITS, m_maximumSignificantDigits.value());
+    } else {
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_INTEGER_DIGITS, m_minimumIntegerDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_FRACTION_DIGITS, m_minimumFractionDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MAX_FRACTION_DIGITS, m_maximumFractionDigits);
-        break;
-    case IntlRoundingType::SignificantDigits:
-        unum_setAttribute(m_numberFormat.get(), UNUM_SIGNIFICANT_DIGITS_USED, true);
-        unum_setAttribute(m_numberFormat.get(), UNUM_MIN_SIGNIFICANT_DIGITS, m_minimumSignificantDigits);
-        unum_setAttribute(m_numberFormat.get(), UNUM_MAX_SIGNIFICANT_DIGITS, m_maximumSignificantDigits);
-        break;
-    default:
-        RELEASE_ASSERT_NOT_REACHED();
-        break;
     }
 
     status = U_ZERO_ERROR;
@@ -150,20 +188,14 @@ JSObject* IntlPluralRules::resolvedOptio
     options->putDirect(vm, vm.propertyNames->locale, jsNontrivialString(vm, m_locale));
     options->putDirect(vm, vm.propertyNames->type, jsNontrivialString(vm, m_type == Type::Ordinal ? "ordinal"_s : "cardinal"_s));
     options->putDirect(vm, vm.propertyNames->minimumIntegerDigits, jsNumber(m_minimumIntegerDigits));
-    switch (m_roundingType) {
-    case IntlRoundingType::FractionDigits:
-        options->putDirect(vm, vm.propertyNames->minimumFractionDigits, jsNumber(m_minimumFractionDigits));
-        options->putDirect(vm, vm.propertyNames->maximumFractionDigits, jsNumber(m_maximumFractionDigits));
-        break;
-    case IntlRoundingType::SignificantDigits:
-        options->putDirect(vm, vm.propertyNames->minimumSignificantDigits, jsNumber(m_minimumSignificantDigits));
-        options->putDirect(vm, vm.propertyNames->maximumSignificantDigits, jsNumber(m_maximumSignificantDigits));
-        break;
-    default:
-        RELEASE_ASSERT_NOT_REACHED();
-        break;
+    options->putDirect(vm, vm.propertyNames->minimumFractionDigits, jsNumber(m_minimumFractionDigits));
+    options->putDirect(vm, vm.propertyNames->maximumFractionDigits, jsNumber(m_maximumFractionDigits));
+    if (m_minimumSignificantDigits) {
+        options->putDirect(vm, vm.propertyNames->minimumSignificantDigits, jsNumber(m_minimumSignificantDigits.value()));
+        options->putDirect(vm, vm.propertyNames->maximumSignificantDigits, jsNumber(m_maximumSignificantDigits.value()));
     }
 
+#if 0
     JSArray* categories = JSArray::tryCreate(vm, globalObject->arrayStructureForIndexingTypeDuringAllocation(ArrayWithContiguous), 0);
     if (UNLIKELY(!categories)) {
         throwOutOfMemoryError(globalObject, scope);
@@ -183,6 +215,7 @@ JSObject* IntlPluralRules::resolvedOptio
         RETURN_IF_EXCEPTION(scope, { });
     }
     options->putDirect(vm, Identifier::fromString(vm, "pluralCategories"), categories);
+#endif
 
     RELEASE_AND_RETURN(scope, options);
 }
@@ -198,11 +231,35 @@ JSValue IntlPluralRules::select(JSGlobal
     if (!std::isfinite(value))
         return jsNontrivialString(vm, "other"_s);
 
+#if 0
     UErrorCode status = U_ZERO_ERROR;
     Vector<UChar, 8> result(8);
     auto length = uplrules_selectWithFormat(m_pluralRules.get(), value, m_numberFormat.get(), result.data(), result.size(), &status);
     if (U_FAILURE(status))
         return throwTypeError(globalObject, scope, "failed to select plural value"_s);
+#else
+    UErrorCode status = U_ZERO_ERROR;
+    Vector<UChar, 32> buffer(32);
+    auto length = unum_formatDouble(m_numberFormat.get(), value, buffer.data(), buffer.size(), nullptr, &status);
+    if (status == U_BUFFER_OVERFLOW_ERROR) {
+        buffer.grow(length);
+        status = U_ZERO_ERROR;
+        unum_formatDouble(m_numberFormat.get(), value, buffer.data(), length, nullptr, &status);
+    }
+    if (U_FAILURE(status))
+        return throwTypeError(globalObject, scope, "failed to select plural value"_s);
+
+    double formatted = unum_parseDouble(m_numberFormat.get(), buffer.data(), length, nullptr, &status);
+    if (U_FAILURE(status))
+        return throwTypeError(globalObject, scope, "failed to select plural value"_s);
+
+    // Can only be 'zero', 'one', 'two', 'few', 'many' or 'other'
+    status = U_ZERO_ERROR;
+    Vector<UChar, 8> result(8);
+    length = uplrules_select(m_pluralRules.get(), formatted, result.data(), result.size(), &status);
+    if (U_FAILURE(status))
+        return throwTypeError(globalObject, scope, "failed to select plural value"_s);
+#endif
 
     return jsString(vm, String(result.data(), length));
 }
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlPluralRules.h webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlPluralRules.h
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlPluralRules.h	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlPluralRules.h	2021-05-21 15:52:00.625456493 -0500
@@ -26,10 +26,9 @@
 
 #pragma once
 
-#include "IntlNumberFormat.h"
+#include "JSObject.h"
 #include <unicode/unum.h>
 #include <unicode/upluralrules.h>
-#include <wtf/unicode/icu/ICUHelpers.h>
 
 namespace JSC {
 
@@ -57,9 +56,6 @@ public:
 
     DECLARE_INFO;
 
-    template<typename IntlType>
-    friend void setNumberFormatDigitOptions(JSGlobalObject*, IntlType*, Optional<JSObject&>, unsigned minimumFractionDigitsDefault, unsigned maximumFractionDigitsDefault, IntlNotation);
-
     void initializePluralRules(JSGlobalObject*, JSValue locales, JSValue options);
     JSValue select(JSGlobalObject*, double value) const;
     JSObject* resolvedOptions(JSGlobalObject*) const;
@@ -73,8 +69,12 @@ private:
 
     enum class Type : bool { Cardinal, Ordinal };
 
-    using UPluralRulesDeleter = ICUDeleter<uplrules_close>;
-    using UNumberFormatDeleter = ICUDeleter<unum_close>;
+    struct UPluralRulesDeleter {
+        void operator()(UPluralRules*) const;
+    };
+    struct UNumberFormatDeleter {
+        void operator()(UNumberFormat*) const;
+    };
 
     std::unique_ptr<UPluralRules, UPluralRulesDeleter> m_pluralRules;
     std::unique_ptr<UNumberFormat, UNumberFormatDeleter> m_numberFormat;
@@ -83,9 +83,8 @@ private:
     unsigned m_minimumIntegerDigits { 1 };
     unsigned m_minimumFractionDigits { 0 };
     unsigned m_maximumFractionDigits { 3 };
-    unsigned m_minimumSignificantDigits { 0 };
-    unsigned m_maximumSignificantDigits { 0 };
-    IntlRoundingType m_roundingType { IntlRoundingType::FractionDigits };
+    Optional<unsigned> m_minimumSignificantDigits;
+    Optional<unsigned> m_maximumSignificantDigits;
     Type m_type { Type::Cardinal };
 };
 
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.cpp webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.cpp
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.cpp	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.cpp	2021-05-21 12:46:18.646631555 -0500
@@ -27,7 +27,7 @@
 #include "config.h"
 #include "IntlRelativeTimeFormat.h"
 
-#include "IntlNumberFormatInlines.h"
+#include "IntlNumberFormat.h"
 #include "IntlObjectInlines.h"
 #include "JSCInlines.h"
 #include "ObjectConstructor.h"
@@ -40,6 +40,18 @@ const ClassInfo IntlRelativeTimeFormat::
 namespace IntlRelativeTimeFormatInternal {
 }
 
+void IntlRelativeTimeFormat::URelativeDateTimeFormatterDeleter::operator()(URelativeDateTimeFormatter* relativeDateTimeFormatter) const
+{
+    if (relativeDateTimeFormatter)
+        ureldatefmt_close(relativeDateTimeFormatter);
+}
+
+void IntlRelativeTimeFormat::UNumberFormatDeleter::operator()(UNumberFormat* numberFormat) const
+{
+    if (numberFormat)
+        unum_close(numberFormat);
+}
+
 IntlRelativeTimeFormat* IntlRelativeTimeFormat::create(VM& vm, Structure* structure)
 {
     auto* format = new (NotNull, allocateCell<IntlRelativeTimeFormat>(vm.heap)) IntlRelativeTimeFormat(vm, structure);
@@ -317,8 +329,7 @@ JSValue IntlRelativeTimeFormat::formatTo
             RETURN_IF_EXCEPTION(scope, { });
         }
 
-        IntlFieldIterator fieldIterator(*iterator.get());
-        IntlNumberFormat::formatToPartsInternal(globalObject, IntlNumberFormat::Style::Decimal, absValue, formattedNumber, fieldIterator, parts, jsString(vm, singularUnit(unit).toString()));
+        IntlNumberFormat::formatToPartsInternal(globalObject, absValue, formattedNumber, iterator.get(), parts, jsString(vm, singularUnit(unit).toString()));
         RETURN_IF_EXCEPTION(scope, { });
     }
 
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.h webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.h
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.h	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.h	2021-05-21 12:46:18.646631555 -0500
@@ -28,7 +28,6 @@
 
 #include "JSObject.h"
 #include <unicode/ureldatefmt.h>
-#include <wtf/unicode/icu/ICUHelpers.h>
 
 namespace JSC {
 
@@ -72,8 +71,12 @@ private:
 
     enum class Style : uint8_t { Long, Short, Narrow };
 
-    using URelativeDateTimeFormatterDeleter = ICUDeleter<ureldatefmt_close>;
-    using UNumberFormatDeleter = ICUDeleter<unum_close>;
+    struct URelativeDateTimeFormatterDeleter {
+        void operator()(URelativeDateTimeFormatter*) const;
+    };
+    struct UNumberFormatDeleter {
+        void operator()(UNumberFormat*) const;
+    };
 
     static ASCIILiteral styleString(Style);
 
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/JSDateMath.cpp webkitgtk-2.32.1/Source/JavaScriptCore/runtime/JSDateMath.cpp
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/JSDateMath.cpp	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/JSDateMath.cpp	2021-05-21 18:20:02.452348872 -0500
@@ -315,7 +315,7 @@ void DateCache::timeZoneCacheSlow()
 {
     // Do not use icu::TimeZone::createDefault. ICU internally has a cache for timezone and createDefault returns this cached value.
     ASSERT(!m_timeZoneCache);
-    m_timeZoneCache = std::unique_ptr<OpaqueICUTimeZone, OpaqueICUTimeZoneDeleter>(bitwise_cast<OpaqueICUTimeZone*>(icu::TimeZone::detectHostTimeZone()));
+    m_timeZoneCache = std::unique_ptr<OpaqueICUTimeZone, OpaqueICUTimeZoneDeleter>(bitwise_cast<OpaqueICUTimeZone*>(icu::TimeZone::createDefault()));
 }
 
 void DateCache::reset()
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/JSGlobalObject.cpp webkitgtk-2.32.1/Source/JavaScriptCore/runtime/JSGlobalObject.cpp
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/JSGlobalObject.cpp	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/JSGlobalObject.cpp	2021-05-21 18:23:04.061307663 -0500
@@ -78,18 +78,12 @@
 #include "IntlDateTimeFormatPrototype.h"
 #include "IntlDisplayNames.h"
 #include "IntlDisplayNamesPrototype.h"
-#include "IntlListFormat.h"
-#include "IntlListFormatPrototype.h"
-#include "IntlLocale.h"
-#include "IntlLocalePrototype.h"
 #include "IntlNumberFormat.h"
 #include "IntlNumberFormatConstructor.h"
 #include "IntlNumberFormatPrototype.h"
 #include "IntlObject.h"
 #include "IntlPluralRules.h"
 #include "IntlPluralRulesPrototype.h"
-#include "IntlRelativeTimeFormat.h"
-#include "IntlRelativeTimeFormatPrototype.h"
 #include "IntlSegmentIterator.h"
 #include "IntlSegmentIteratorPrototype.h"
 #include "IntlSegmenter.h"
@@ -1034,30 +1028,12 @@ capitalName ## Constructor* lowerName ##
             IntlDisplayNamesPrototype* displayNamesPrototype = IntlDisplayNamesPrototype::create(init.vm, IntlDisplayNamesPrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
             init.set(IntlDisplayNames::createStructure(init.vm, globalObject, displayNamesPrototype));
         });
-    m_listFormatStructure.initLater(
-        [] (const Initializer<Structure>& init) {
-            JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
-            IntlListFormatPrototype* listFormatPrototype = IntlListFormatPrototype::create(init.vm, IntlListFormatPrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
-            init.set(IntlListFormat::createStructure(init.vm, globalObject, listFormatPrototype));
-        });
-    m_localeStructure.initLater(
-        [] (const Initializer<Structure>& init) {
-            JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
-            IntlLocalePrototype* localePrototype = IntlLocalePrototype::create(init.vm, IntlLocalePrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
-            init.set(IntlLocale::createStructure(init.vm, globalObject, localePrototype));
-        });
     m_pluralRulesStructure.initLater(
         [] (const Initializer<Structure>& init) {
             JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
             IntlPluralRulesPrototype* pluralRulesPrototype = IntlPluralRulesPrototype::create(init.vm, globalObject, IntlPluralRulesPrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
             init.set(IntlPluralRules::createStructure(init.vm, globalObject, pluralRulesPrototype));
         });
-    m_relativeTimeFormatStructure.initLater(
-        [] (const Initializer<Structure>& init) {
-            JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
-            IntlRelativeTimeFormatPrototype* relativeTimeFormatPrototype = IntlRelativeTimeFormatPrototype::create(init.vm, IntlRelativeTimeFormatPrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
-            init.set(IntlRelativeTimeFormat::createStructure(init.vm, globalObject, relativeTimeFormatPrototype));
-        });
     m_segmentIteratorStructure.initLater(
         [] (const Initializer<Structure>& init) {
             JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
@@ -1935,10 +1911,7 @@ void JSGlobalObject::visitChildrenImpl(J
     thisObject->m_defaultCollator.visit(visitor);
     thisObject->m_collatorStructure.visit(visitor);
     thisObject->m_displayNamesStructure.visit(visitor);
-    thisObject->m_listFormatStructure.visit(visitor);
-    thisObject->m_localeStructure.visit(visitor);
     thisObject->m_pluralRulesStructure.visit(visitor);
-    thisObject->m_relativeTimeFormatStructure.visit(visitor);
     thisObject->m_segmentIteratorStructure.visit(visitor);
     thisObject->m_segmenterStructure.visit(visitor);
     thisObject->m_segmentsStructure.visit(visitor);
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/JSGlobalObjectFunctions.cpp webkitgtk-2.32.1/Source/JavaScriptCore/runtime/JSGlobalObjectFunctions.cpp
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/JSGlobalObjectFunctions.cpp	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/JSGlobalObjectFunctions.cpp	2021-05-20 15:31:28.090789302 -0500
@@ -168,7 +168,7 @@ static JSValue decode(JSGlobalObject* gl
             int charLen = 0;
             if (k <= length - 3 && isASCIIHexDigit(p[1]) && isASCIIHexDigit(p[2])) {
                 const char b0 = Lexer<CharType>::convertHex(p[1], p[2]);
-                const int sequenceLen = 1 + U8_COUNT_TRAIL_BYTES(b0);
+                const int sequenceLen = 1 + U8_COUNT_TRAIL_BYTES(static_cast<unsigned char>(b0));
                 if (k <= length - sequenceLen * 3) {
                     charLen = sequenceLen * 3;
                     uint8_t sequence[U8_MAX_LENGTH];
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/JSGlobalObject.h webkitgtk-2.32.1/Source/JavaScriptCore/runtime/JSGlobalObject.h
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/JSGlobalObject.h	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/JSGlobalObject.h	2021-05-21 10:56:34.299869188 -0500
@@ -311,10 +311,7 @@ public:
     LazyProperty<JSGlobalObject, IntlCollator> m_defaultCollator;
     LazyProperty<JSGlobalObject, Structure> m_collatorStructure;
     LazyProperty<JSGlobalObject, Structure> m_displayNamesStructure;
-    LazyProperty<JSGlobalObject, Structure> m_listFormatStructure;
-    LazyProperty<JSGlobalObject, Structure> m_localeStructure;
     LazyProperty<JSGlobalObject, Structure> m_pluralRulesStructure;
-    LazyProperty<JSGlobalObject, Structure> m_relativeTimeFormatStructure;
     LazyProperty<JSGlobalObject, Structure> m_segmentIteratorStructure;
     LazyProperty<JSGlobalObject, Structure> m_segmenterStructure;
     LazyProperty<JSGlobalObject, Structure> m_segmentsStructure;
@@ -846,11 +843,8 @@ public:
     Structure* collatorStructure() { return m_collatorStructure.get(this); }
     Structure* dateTimeFormatStructure() { return m_dateTimeFormatStructure.get(this); }
     Structure* displayNamesStructure() { return m_displayNamesStructure.get(this); }
-    Structure* listFormatStructure() { return m_listFormatStructure.get(this); }
     Structure* numberFormatStructure() { return m_numberFormatStructure.get(this); }
-    Structure* localeStructure() { return m_localeStructure.get(this); }
     Structure* pluralRulesStructure() { return m_pluralRulesStructure.get(this); }
-    Structure* relativeTimeFormatStructure() { return m_relativeTimeFormatStructure.get(this); }
     Structure* segmentIteratorStructure() { return m_segmentIteratorStructure.get(this); }
     Structure* segmenterStructure() { return m_segmenterStructure.get(this); }
     Structure* segmentsStructure() { return m_segmentsStructure.get(this); }
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/VM.cpp webkitgtk-2.32.1/Source/JavaScriptCore/runtime/VM.cpp
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/VM.cpp	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/VM.cpp	2021-05-21 10:57:21.888120502 -0500
@@ -69,11 +69,8 @@
 #include "IntlCollator.h"
 #include "IntlDateTimeFormat.h"
 #include "IntlDisplayNames.h"
-#include "IntlListFormat.h"
-#include "IntlLocale.h"
 #include "IntlNumberFormat.h"
 #include "IntlPluralRules.h"
-#include "IntlRelativeTimeFormat.h"
 #include "IntlSegmentIterator.h"
 #include "IntlSegmenter.h"
 #include "IntlSegments.h"
@@ -317,11 +314,8 @@ VM::VM(VMType vmType, HeapType heapType,
     , intlCollatorHeapCellType(IsoHeapCellType::create<IntlCollator>())
     , intlDateTimeFormatHeapCellType(IsoHeapCellType::create<IntlDateTimeFormat>())
     , intlDisplayNamesHeapCellType(IsoHeapCellType::create<IntlDisplayNames>())
-    , intlListFormatHeapCellType(IsoHeapCellType::create<IntlListFormat>())
-    , intlLocaleHeapCellType(IsoHeapCellType::create<IntlLocale>())
     , intlNumberFormatHeapCellType(IsoHeapCellType::create<IntlNumberFormat>())
     , intlPluralRulesHeapCellType(IsoHeapCellType::create<IntlPluralRules>())
-    , intlRelativeTimeFormatHeapCellType(IsoHeapCellType::create<IntlRelativeTimeFormat>())
     , intlSegmentIteratorHeapCellType(IsoHeapCellType::create<IntlSegmentIterator>())
     , intlSegmenterHeapCellType(IsoHeapCellType::create<IntlSegmenter>())
     , intlSegmentsHeapCellType(IsoHeapCellType::create<IntlSegments>())
@@ -1542,11 +1536,8 @@ DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(
 DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlCollatorSpace, intlCollatorHeapCellType.get(), IntlCollator)
 DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlDateTimeFormatSpace, intlDateTimeFormatHeapCellType.get(), IntlDateTimeFormat)
 DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlDisplayNamesSpace, intlDisplayNamesHeapCellType.get(), IntlDisplayNames)
-DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlListFormatSpace, intlListFormatHeapCellType.get(), IntlListFormat)
-DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlLocaleSpace, intlLocaleHeapCellType.get(), IntlLocale)
 DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlNumberFormatSpace, intlNumberFormatHeapCellType.get(), IntlNumberFormat)
 DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlPluralRulesSpace, intlPluralRulesHeapCellType.get(), IntlPluralRules)
-DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlRelativeTimeFormatSpace, intlRelativeTimeFormatHeapCellType.get(), IntlRelativeTimeFormat)
 DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlSegmentIteratorSpace, intlSegmentIteratorHeapCellType.get(), IntlSegmentIterator)
 DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlSegmenterSpace, intlSegmenterHeapCellType.get(), IntlSegmenter)
 DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER_SLOW(intlSegmentsSpace, intlSegmentsHeapCellType.get(), IntlSegments)
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/VM.h webkitgtk-2.32.1/Source/JavaScriptCore/runtime/VM.h
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/VM.h	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/VM.h	2021-05-21 10:57:53.296286350 -0500
@@ -129,11 +129,8 @@ class IntlCache;
 class IntlCollator;
 class IntlDateTimeFormat;
 class IntlDisplayNames;
-class IntlListFormat;
-class IntlLocale;
 class IntlNumberFormat;
 class IntlPluralRules;
-class IntlRelativeTimeFormat;
 class IntlSegmentIterator;
 class IntlSegmenter;
 class IntlSegments;
@@ -391,11 +388,8 @@ public:
     std::unique_ptr<IsoHeapCellType> intlCollatorHeapCellType;
     std::unique_ptr<IsoHeapCellType> intlDateTimeFormatHeapCellType;
     std::unique_ptr<IsoHeapCellType> intlDisplayNamesHeapCellType;
-    std::unique_ptr<IsoHeapCellType> intlListFormatHeapCellType;
-    std::unique_ptr<IsoHeapCellType> intlLocaleHeapCellType;
     std::unique_ptr<IsoHeapCellType> intlNumberFormatHeapCellType;
     std::unique_ptr<IsoHeapCellType> intlPluralRulesHeapCellType;
-    std::unique_ptr<IsoHeapCellType> intlRelativeTimeFormatHeapCellType;
     std::unique_ptr<IsoHeapCellType> intlSegmentIteratorHeapCellType;
     std::unique_ptr<IsoHeapCellType> intlSegmenterHeapCellType;
     std::unique_ptr<IsoHeapCellType> intlSegmentsHeapCellType;
@@ -558,11 +552,8 @@ public:
     DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlCollatorSpace)
     DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlDateTimeFormatSpace)
     DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlDisplayNamesSpace)
-    DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlListFormatSpace)
-    DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlLocaleSpace)
     DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlNumberFormatSpace)
     DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlPluralRulesSpace)
-    DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlRelativeTimeFormatSpace)
     DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlSegmentIteratorSpace)
     DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlSegmenterSpace)
     DYNAMIC_ISO_SUBSPACE_DEFINE_MEMBER(intlSegmentsSpace)
diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/tools/JSDollarVM.cpp webkitgtk-2.32.1/Source/JavaScriptCore/tools/JSDollarVM.cpp
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/tools/JSDollarVM.cpp	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/tools/JSDollarVM.cpp	2021-05-21 15:54:04.322109454 -0500
@@ -57,7 +57,6 @@
 #include <wtf/Language.h>
 #include <wtf/ProcessID.h>
 #include <wtf/StringPrintStream.h>
-#include <wtf/unicode/icu/ICUHelpers.h>
 
 #if ENABLE(WEBASSEMBLY)
 #include "JSWebAssemblyHelpers.h"
@@ -3493,7 +3492,9 @@ JSC_DEFINE_HOST_FUNCTION(functionSetUser
 JSC_DEFINE_HOST_FUNCTION(functionICUVersion, (JSGlobalObject*, CallFrame*))
 {
     DollarVMAssertScope assertScope;
-    return JSValue::encode(jsNumber(WTF::ICU::majorVersion()));
+    UVersionInfo versionInfo;
+    u_getVersion(versionInfo);
+    return JSValue::encode(jsNumber(versionInfo[0]));
 }
 
 JSC_DEFINE_HOST_FUNCTION(functionICUHeaderVersion, (JSGlobalObject*, CallFrame*))
diff -urp webkitgtk-2.32.1.gstreamer/Source/WebCore/platform/text/CharacterProperties.h webkitgtk-2.32.1/Source/WebCore/platform/text/CharacterProperties.h
--- webkitgtk-2.32.1.gstreamer/Source/WebCore/platform/text/CharacterProperties.h	2021-02-26 03:57:14.000000000 -0600
+++ webkitgtk-2.32.1/Source/WebCore/platform/text/CharacterProperties.h	2021-05-20 18:02:59.510785410 -0500
@@ -41,10 +41,8 @@ static_assert(UBLOCK_SYMBOLS_AND_PICTOGR
     switch (static_cast<int>(ublock_getCode(character))) {
     case UBLOCK_MISCELLANEOUS_SYMBOLS:
     case UBLOCK_DINGBATS:
-    case UBLOCK_MISCELLANEOUS_SYMBOLS_AND_PICTOGRAPHS:
     case UBLOCK_EMOTICONS:
     case UBLOCK_TRANSPORT_AND_MAP_SYMBOLS:
-    case UBLOCK_SUPPLEMENTAL_SYMBOLS_AND_PICTOGRAPHS:
     case UBLOCK_SYMBOLS_AND_PICTOGRAPHS_EXTENDED_A:
         return true;
     default:
@@ -80,12 +78,12 @@ inline bool isEmojiRegionalIndicator(UCh
 
 inline bool isEmojiWithPresentationByDefault(UChar32 character)
 {
-    return u_hasBinaryProperty(character, UCHAR_EMOJI_PRESENTATION);
+    return false;
 }
 
 inline bool isEmojiModifierBase(UChar32 character)
 {
-    return u_hasBinaryProperty(character, UCHAR_EMOJI_MODIFIER_BASE);
+    return false;
 }
 
 inline bool isDefaultIgnorableCodePoint(UChar32 character)
